package cz.metacentrum.perun.cabinet.model;

import java.io.Serializable;

/**
 * This class represents a category (of publication). I.e. patent, article in journal etc.
 * Each category is supposed to have some rank, which expresses the importance of given category.
 *
 * @author Jiri Harazim <harazim@mail.muni.cz>
 * @author Pavel Zlamal <256627@mail.muni.cz>
 */
public class Category implements Serializable{

	private static final long serialVersionUID = 1L;

	/**
	 * This field was generated by MyBatis Generator.
	 * This field corresponds to the database column CATEGORY.id
	 *
	 * @mbggenerated Wed Nov 02 13:52:56 CET 2011
	 */
	private Integer id;

	/**
	 * This field was generated by MyBatis Generator.
	 * This field corresponds to the database column CATEGORY.name
	 *
	 * @mbggenerated Wed Nov 02 13:52:56 CET 2011
	 */
	private String name;

	/**
	 * This field was generated by MyBatis Generator.
	 * This field corresponds to the database column CATEGORY.rank
	 *
	 * @mbggenerated Wed Nov 02 13:52:56 CET 2011
	 */
	private Double rank;

	public Category(Integer id, String name, Double rank) {
		this.id = id;
		this.name = name;
		this.rank = rank;
	}

	public Category() {

	}

	/**
	 * This method was generated by MyBatis Generator.
	 * This method returns the value of the database column CATEGORY.id
	 *
	 * @return the value of CATEGORY.id
	 *
	 * @mbggenerated Wed Nov 02 13:52:56 CET 2011
	 */
	public Integer getId() {
		return id;
	}

	/**
	 * This method was generated by MyBatis Generator.
	 * This method sets the value of the database column CATEGORY.id
	 *
	 * @param id the value for CATEGORY.id
	 *
	 * @mbggenerated Wed Nov 02 13:52:56 CET 2011
	 */
	public void setId(Integer id) {
		this.id = id;
	}

	/**
	 * This method was generated by MyBatis Generator.
	 * This method returns the value of the database column CATEGORY.name
	 *
	 * @return the value of CATEGORY.name
	 *
	 * @mbggenerated Wed Nov 02 13:52:56 CET 2011
	 */
	public String getName() {
		return name;
	}

	/**
	 * This method was generated by MyBatis Generator.
	 * This method sets the value of the database column CATEGORY.name
	 *
	 * @param name the value for CATEGORY.name
	 *
	 * @mbggenerated Wed Nov 02 13:52:56 CET 2011
	 */
	public void setName(String name) {
		this.name = name == null ? null : name.trim();
	}

	/**
	 * This method was generated by MyBatis Generator.
	 * This method returns the value of the database column CATEGORY.rank
	 *
	 * @return the value of CATEGORY.rank
	 *
	 * @mbggenerated Wed Nov 02 13:52:56 CET 2011
	 */
	public Double getRank() {
		return rank;
	}

	public String getBeanName() {
		return this.getClass().getSimpleName();
	}

	/**
	 * This method was generated by MyBatis Generator.
	 * This method sets the value of the database column CATEGORY.rank
	 *
	 * @param rank the value for CATEGORY.rank
	 *
	 * @mbggenerated Wed Nov 02 13:52:56 CET 2011
	 */
	public void setRank(Double rank) {
		this.rank = rank;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		result = prime * result + ((rank == null) ? 0 : rank.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Category other = (Category) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		if (rank == null) {
			if (other.rank != null)
				return false;
		} else if (!rank.equals(other.rank))
			return false;
		return true;
	}

	@Override
	public String toString() {
		StringBuilder str = new StringBuilder();

		return str.append(getClass().getSimpleName()).append(":[id=").append(id).append(", name=").append(name).append(", rank=").append(rank).append( "]").toString();
	}


}
